      PROGRAM QUANTILE
C
C  SELECTION OF QUANTILES OBTAINED FOR A UNIVARIATE SET OF DATA
C  NOTE:  THE UNIVARIATE DATA SET SIZE MUST BE AT LEAST 2
C
      REAL  X(700)
      CHARACTER  FIN*40,FOUT*40
C
      WRITE(*,*) 'ENTER N (TOTAL NUMBER OF VALUES)'
      READ(*,*) N
      IF(N.LT.2) GO TO 80
      WRITE(*,*) 'ENTER FILE NAME OF INPUT DATA'
      READ(*,'(A)') FIN
      WRITE(*,*) 'ENTER FILE NAME OF OUTPUT DATA'
      READ(*,'(A)') FOUT
      WRITE(*,*) 'ENTER P FOR P-TH QUANTILE (0 < P < 1)'
      READ(*,*) P
      OPEN(4,FILE=FIN)
      READ(4,*) (X(I),I=1,N)
      CLOSE(4)
      OPEN(7,FILE=FOUT,STATUS='NEW')
C
      J = N
      K = J/2+1
   10 K = K-1
      W = X(K)
      GO TO 30
   20 W = X(J)
      X(J) = X(1)
      J = J-1
   30 II = K
   40 L = 2*II
      IF(L-J) 50,60,70
   50 IF(X(L+1).GE.X(L)) L = L+1
   60 IF(W.GE.X(L)) GO TO 70
      X(II) = X(L)
      II = L
      GO TO 40
   70 X(II) = W
      IF(K.GT.1) GO TO 10
      IF(J.GE.2) GO TO 20
      WRITE(7,*) 'P =', P
      K = MAX(1,NINT(P*N+0.5))
      WRITE(7,*) 'P-TH QUANTILE =',X(K)
      WRITE(7,*) '0.0-TH QUANTILE (MINIMUM VALUE) =',X(1)
      K = MAX(1,NINT(0.05*N+0.5))
      WRITE(7,*) 'O.O5-TH QUANTILE =',X(K)
      K = MAX(1,NINT(0.1*N+0.5))
      WRITE(7,*) '0.1-TH QUANTILE =',X(K)
      K = MAX(1,NINT(0.25*N+0.5))
      WRITE(7,*) '0.25-TH QUANTILE =',X(K)
      K = INT(0.5*N+0.51)
      Y = X(K)
      L = N/2
      IF(K.EQ.L) Y = (X(K)+X(K+1))/2
      WRITE(7,*) '0.5-TH QUANTILE (MEDIAN VALUE) =',Y
      K = MIN(N,NINT(0.75*N+0.5))
      WRITE(7,*) '0.75-TH QUANTILE =',X(K)
      K = MIN(N,NINT(0.9*N+0.5))
      WRITE(7,*) '0.9-TH QUANTILE =',X(K)
      K = MIN(N,NINT(0.95*N+0.5))
      WRITE(7,*) '0.95-TH QUANTILE =',X(K)
      WRITE(7,*) '1.0-TH QUANTILE (MAXIMUM VALUE) =',X(N)
      CLOSE(7)
      STOP
   80 END
