      PROGRAM INCBETA
      DOUBLE PRECISION X,P,Q,OUT,BETAIN
   10 WRITE(*,20) ' ENTER X VALUE, A, AND B PARAMETERS, OR,',
     +            ' ENTER ANY LETTER OF ALPHABET TO QUIT:'
   20 FORMAT(/,A,/,A,/)
      READ(*,*) X,P,Q
      OUT = BETAIN(X,P,Q)
      WRITE(*,30) ' INCOMPLETE BETA CDF VALUE IS: ',OUT
   30 FORMAT(A,G15.8)
      GO TO 10
   40 END
C
      DOUBLE PRECISION FUNCTION BETAIN(X,A,B)
      DOUBLE PRECISION X,A,B,ONE,TOL,AB,CX,XX,AA,BB,TERM,AI,RX,TEMP,
     +       DLNBTA
      LOGICAL INDEX
      ONE = 1.0D0
      TOL = 0.1D-7
      BETAIN = X
      AB = A+B
      CX = ONE-X
      IF(A.GE.AB*X) GO TO 10
      XX = CX
      CX = X
      AA = B
      BB = A
      INDEX = .TRUE.
      GO TO 20
   10 XX = X
      AA = A
      BB = B
      INDEX = .FALSE.
   20 TERM = ONE
      AI = ONE
      BETAIN = ONE
      NS = IDINT(BB+CX*AB)
      RX = XX/CX
   30 TEMP = BB-AI
      IF(NS.EQ.0) RX = XX
   40 TERM = TERM*TEMP*RX/(AA+AI)
      BETAIN = BETAIN+TERM
      TEMP = DABS(TERM)
      IF(TEMP.LE.TOL.AND.TEMP.LE.TOL*BETAIN) GO TO 50
      AI = AI+1
      NS = NS-1
      IF(NS.GE.0) GO TO 30
      TEMP = AB
      AB = AB+1
      GO TO 40
   50 BETAIN = BETAIN*DEXP(AA*DLOG(XX)+(BB-1)*DLOG(CX)-
     +         DLNBTA(AA,BB))/AA
      IF(INDEX) BETAIN = ONE-BETAIN
      END
C
      DOUBLE PRECISION FUNCTION DLNBTA(A,B)
      DOUBLE PRECISION A,B,DLNGAM
      DLNBTA = DLNGAM(A)+DLNGAM(B)-DLNGAM(A+B)
      END
C
C
      DOUBLE PRECISION FUNCTION DLNGAM(X)
      DOUBLE PRECISION X,ONE,Z,D,PI,F
      ONE  = 1.0D0
      Z  = X-1
      D  = ONE
      PI = DATAN(ONE)*4
      F  = Z+10
      DO 10 J = 1, 9
         D = D*(Z+J)
   10 CONTINUE
      DLNGAM = (F*2-1)*DLOG(F)/2-F+DLOG(PI*2)/2-DLOG(D)+ONE/(F*12)
     +         -ONE/((F**3)*360)+ONE/((F**5)*1260)-ONE/((F**7)*1680)
     +         +ONE/((F**9)*1188)
      END
