      PROGRAM NHYPERG
C
      INTEGER  R,C,I,K,L,M,N
      REAL*8  H,T,P0,P1,P2,ONE,ZERO
C
      ONE = 1.0D0
      ZERO = 0.0D0
      WRITE(*,*) 'K = # of marked items in sample'
      WRITE(*,*) 'R = # of items in sample'
      WRITE(*,*) 'C = # of marked items in population'
      WRITE(*,*) 'N = # of items in population'
      WRITE(*,*) 'Enter K, R, C, N for negative hypergeometric dist-n'
      READ(*,*) K,R,C,N
      L = K
      M = N-C+K
      IF(R.LT.L)  THEN
         P0 = ZERO
         P1 = ZERO
         P2 = ONE
         GO TO 30
      END IF
      IF(R.GT.M)  THEN
         P0 = ZERO
         P1 = ONE
         P2 = ZERO
         GO TO 30
      END IF
      H = 1.0D-100
      P0 = H
      P1 = H
      IF(R.EQ.L)  THEN
         P2 = H
         T = H
         GO TO 15
      END IF
      DO 10 I = L,R-1
         H = H*I*(N+K-C-I)/(N-I)/(I+1-K)
         P1 = P1+H
   10 CONTINUE
      P0 = H
      T = P1
      P2 = H
      IF(R.EQ.M)  GO TO 25
   15 DO 20 I = R,M-1
         H = H*I*(N+K-C-I)/(N-I)/(I+1-K)
         T = T+H
         P2 = P2+H
   20 CONTINUE
   25 P0 = P0/T
      P1 = P1/T
      P2 = P2/T
   30 WRITE(*,*) 'P(R = ',R,' | K, C, N)      = ',P0
      WRITE(*,*) 'P(R  ',R,' | K, C, N)      = ',P1
      WRITE(*,*) 'P(R  ',R,' | K, C, N)      = ',P2
      END
