      PROGRAM FPROPT
      IMPLICIT REAL*8(A-H,O-Z)
C
C   THIS PROGRAM OBTAINS THE PROBABILITY THE LARGEST PART'S PROPORTION
C   AMONG M PARTS BEING AS LARGE OR LARGER THAN AN OBSERVED LARGEST
C   PART'S PROPORTION (Y) WHERE THE SUM OF THE M PROPORTIONS EQUALS
C   ONE AND 1  Y  1/M.
C
      WRITE(*,*) 'THIS FISHER PROPORTION TEST PROGRAM IS SATISFACTORY'
      WRITE(*,*) '   FOR M LESS THAN OR EQUAL TO 100.  HIGH PRECISION'
      WRITE(*,*) '   HOLDS ONLY WHEN M IS LESS THAN OR EQUAL TO 80.'
      WRITE(*,*) 'ENTER: NUMBER OF PARTS (M) AND LARGEST PROPORTION (Y)'
      READ(*,*) M,Y
      ZERO = 0.0D0
      ONE = 1.0D0
      K = M-1
      P = ZERO
      C = ONE*M
      L = IDINT(ONE/Y)
      R = C*(ONE-Y)**K
      DO 10 I = 1,L
         P = P+R
         IF(I.EQ.L) GO TO 20
         R = (ZERO-R)*((ONE-Y*(I+1))/(ONE-Y*I))**K*(C-I)/(I+1)
   10 CONTINUE
   20 WRITE(*,*) 'PROBABILITY THAT LARGEST AMONG M PROPORTIONS IS  Y:'
      WRITE(*,*) P
      STOP 'P-VALUE FOR THE FISHER PROPORTION TEST GIVEN ABOVE'
      END
